/* Multitasking.c generated by valac 0.52.4, the Vala compiler
 * generated from Multitasking.vala, do not modify */

/*
* Copyright 2011-2019 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Tom Beckmann
*/

#include "pantheon-desktop.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

enum  {
	PANTHEON_SHELL_MULTITASKING_0_PROPERTY,
	PANTHEON_SHELL_MULTITASKING_NUM_PROPERTIES
};
static GParamSpec* pantheon_shell_multitasking_properties[PANTHEON_SHELL_MULTITASKING_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PantheonShellMultitaskingPrivate {
	GSettings* behavior_settings;
	GtkRevealer* custom_command_revealer;
	GeeHashSet* keys_using_custom_command;
};

struct _Block4Data {
	int _ref_count_;
	PantheonShellMultitasking* self;
	GtkComboBoxText* topleft;
	GtkComboBoxText* topright;
	GtkComboBoxText* bottomleft;
	GtkComboBoxText* bottomright;
};

static gint PantheonShellMultitasking_private_offset;
static gpointer pantheon_shell_multitasking_parent_class = NULL;

#define PANTHEON_SHELL_MULTITASKING_CUSTOM_COMMAND_ID "5"
#define PANTHEON_SHELL_MULTITASKING_ANIMATIONS_SCHEMA "org.pantheon.desktop.gala.animations"
#define PANTHEON_SHELL_MULTITASKING_ANIMATIONS_KEY "enable-animations"
static void pantheon_shell_multitasking_hotcorner_changed (PantheonShellMultitasking* self,
                                                    const gchar* settings_key,
                                                    GtkComboBoxText* combo);
static GtkComboBoxText* pantheon_shell_multitasking_create_hotcorner (PantheonShellMultitasking* self);
static GObject * pantheon_shell_multitasking_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _pantheon_shell_multitasking___lambda12_ (Block4Data* _data4_);
static void __pantheon_shell_multitasking___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void _pantheon_shell_multitasking___lambda13_ (Block4Data* _data4_);
static void __pantheon_shell_multitasking___lambda13__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void _pantheon_shell_multitasking___lambda14_ (Block4Data* _data4_);
static void __pantheon_shell_multitasking___lambda14__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void _pantheon_shell_multitasking___lambda15_ (Block4Data* _data4_);
static void __pantheon_shell_multitasking___lambda15__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void pantheon_shell_multitasking_finalize (GObject * obj);
static GType pantheon_shell_multitasking_get_type_once (void);

static inline gpointer
pantheon_shell_multitasking_get_instance_private (PantheonShellMultitasking* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonShellMultitasking_private_offset);
}

static void
pantheon_shell_multitasking_hotcorner_changed (PantheonShellMultitasking* self,
                                               const gchar* settings_key,
                                               GtkComboBoxText* combo)
{
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkRevealer* _tmp7_;
	GeeHashSet* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (settings_key != NULL);
	g_return_if_fail (combo != NULL);
	_tmp0_ = self->priv->behavior_settings;
	_tmp1_ = gtk_combo_box_get_active_id ((GtkComboBox*) combo);
	_tmp2_ = _tmp1_;
	g_settings_set_enum (_tmp0_, settings_key, atoi (_tmp2_));
	_tmp3_ = gtk_combo_box_get_active_id ((GtkComboBox*) combo);
	_tmp4_ = _tmp3_;
	if (g_strcmp0 (_tmp4_, PANTHEON_SHELL_MULTITASKING_CUSTOM_COMMAND_ID) == 0) {
		GeeHashSet* _tmp5_;
		_tmp5_ = self->priv->keys_using_custom_command;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, settings_key);
	} else {
		GeeHashSet* _tmp6_;
		_tmp6_ = self->priv->keys_using_custom_command;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, settings_key);
	}
	_tmp7_ = self->priv->custom_command_revealer;
	_tmp8_ = self->priv->keys_using_custom_command;
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
	_tmp10_ = _tmp9_;
	gtk_revealer_set_reveal_child (_tmp7_, _tmp10_ > 0);
}

static GtkComboBoxText*
pantheon_shell_multitasking_create_hotcorner (PantheonShellMultitasking* self)
{
	GtkComboBoxText* box = NULL;
	GtkComboBoxText* _tmp0_;
	GtkComboBoxText* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp0_);
	box = _tmp0_;
	gtk_combo_box_text_append (box, "0", _ ("Do nothing"));
	gtk_combo_box_text_append (box, "1", _ ("Multitasking View"));
	gtk_combo_box_text_append (box, "2", _ ("Maximize current window"));
	gtk_combo_box_text_append (box, "4", _ ("Show Applications Menu"));
	gtk_combo_box_text_append (box, "7", _ ("Show all windows"));
	gtk_combo_box_text_append (box, "8", _ ("Switch to new workspace"));
	gtk_combo_box_text_append (box, PANTHEON_SHELL_MULTITASKING_CUSTOM_COMMAND_ID, _ ("Execute custom command"));
	result = box;
	return result;
}

PantheonShellMultitasking*
pantheon_shell_multitasking_construct (GType object_type)
{
	PantheonShellMultitasking * self = NULL;
	self = (PantheonShellMultitasking*) g_object_new (object_type, NULL);
	return self;
}

PantheonShellMultitasking*
pantheon_shell_multitasking_new (void)
{
	return pantheon_shell_multitasking_construct (PANTHEON_SHELL_TYPE_MULTITASKING);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		PantheonShellMultitasking* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->bottomright);
		_g_object_unref0 (_data4_->bottomleft);
		_g_object_unref0 (_data4_->topright);
		_g_object_unref0 (_data4_->topleft);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
_pantheon_shell_multitasking___lambda12_ (Block4Data* _data4_)
{
	PantheonShellMultitasking* self;
	GtkComboBoxText* _tmp0_;
	self = _data4_->self;
	_tmp0_ = _data4_->topleft;
	pantheon_shell_multitasking_hotcorner_changed (self, "hotcorner-topleft", _tmp0_);
}

static void
__pantheon_shell_multitasking___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
	_pantheon_shell_multitasking___lambda12_ (self);
}

static void
_pantheon_shell_multitasking___lambda13_ (Block4Data* _data4_)
{
	PantheonShellMultitasking* self;
	GtkComboBoxText* _tmp0_;
	self = _data4_->self;
	_tmp0_ = _data4_->topright;
	pantheon_shell_multitasking_hotcorner_changed (self, "hotcorner-topright", _tmp0_);
}

static void
__pantheon_shell_multitasking___lambda13__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
	_pantheon_shell_multitasking___lambda13_ (self);
}

static void
_pantheon_shell_multitasking___lambda14_ (Block4Data* _data4_)
{
	PantheonShellMultitasking* self;
	GtkComboBoxText* _tmp0_;
	self = _data4_->self;
	_tmp0_ = _data4_->bottomleft;
	pantheon_shell_multitasking_hotcorner_changed (self, "hotcorner-bottomleft", _tmp0_);
}

static void
__pantheon_shell_multitasking___lambda14__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
	_pantheon_shell_multitasking___lambda14_ (self);
}

static void
_pantheon_shell_multitasking___lambda15_ (Block4Data* _data4_)
{
	PantheonShellMultitasking* self;
	GtkComboBoxText* _tmp0_;
	self = _data4_->self;
	_tmp0_ = _data4_->bottomright;
	pantheon_shell_multitasking_hotcorner_changed (self, "hotcorner-bottomright", _tmp0_);
}

static void
__pantheon_shell_multitasking___lambda15__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
	_pantheon_shell_multitasking___lambda15_ (self);
}

static GObject *
pantheon_shell_multitasking_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PantheonShellMultitasking * self;
	Block4Data* _data4_;
	GSettings* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkLabel* hotcorner_title = NULL;
	GtkLabel* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkComboBoxText* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GtkComboBoxText* _tmp7_;
	GSettings* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkComboBoxText* _tmp11_;
	GtkComboBoxText* _tmp12_;
	GtkComboBoxText* _tmp13_;
	GtkComboBoxText* _tmp14_;
	GSettings* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkComboBoxText* _tmp18_;
	GtkComboBoxText* _tmp19_;
	GtkComboBoxText* _tmp20_;
	GtkComboBoxText* _tmp21_;
	GSettings* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkComboBoxText* _tmp25_;
	GtkComboBoxText* _tmp26_;
	GtkComboBoxText* _tmp27_;
	GtkComboBoxText* _tmp28_;
	GSettings* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GtkComboBoxText* _tmp32_;
	GtkGrid* icon = NULL;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkStyleContext* icon_style_context = NULL;
	GtkGrid* _tmp36_;
	GtkStyleContext* _tmp37_;
	GtkStyleContext* _tmp38_;
	GtkStyleContext* _tmp39_;
	GtkStyleContext* _tmp40_;
	GtkEntry* custom_command = NULL;
	GtkEntry* _tmp41_;
	GtkEntry* _tmp42_;
	GtkLabel* cc_label = NULL;
	GtkLabel* _tmp43_;
	GtkGrid* cc_grid = NULL;
	GtkGrid* _tmp44_;
	GtkGrid* _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	GtkGrid* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkLabel* _tmp51_;
	GtkGrid* _tmp52_;
	GtkEntry* _tmp53_;
	GtkSizeGroup* cc_sizegroup = NULL;
	GtkSizeGroup* _tmp54_;
	GtkSizeGroup* _tmp55_;
	GtkGrid* _tmp56_;
	GtkSizeGroup* _tmp57_;
	GtkEntry* _tmp58_;
	GtkRevealer* _tmp59_;
	GtkGrid* _tmp60_;
	GtkLabel* workspaces_label = NULL;
	GtkLabel* _tmp61_ = NULL;
	GtkCheckButton* fullscreen_checkbutton = NULL;
	GtkCheckButton* _tmp62_;
	GtkCheckButton* maximize_checkbutton = NULL;
	GtkCheckButton* _tmp63_;
	GtkGrid* checkbutton_grid = NULL;
	GtkGrid* _tmp64_ = NULL;
	GtkGrid* _tmp65_;
	GtkCheckButton* _tmp66_;
	GtkGrid* _tmp67_;
	GtkCheckButton* _tmp68_;
	GtkLabel* animations_label = NULL;
	GtkLabel* _tmp69_ = NULL;
	GtkSwitch* animations_switch = NULL;
	GtkSwitch* _tmp70_ = NULL;
	GtkLabel* _tmp71_;
	GtkGrid* _tmp72_;
	GtkComboBoxText* _tmp73_;
	GtkComboBoxText* _tmp74_;
	GtkComboBoxText* _tmp75_;
	GtkComboBoxText* _tmp76_;
	GtkRevealer* _tmp77_;
	GtkLabel* _tmp78_;
	GtkGrid* _tmp79_;
	GtkLabel* _tmp80_;
	GtkSwitch* _tmp81_;
	GSettings* animations_settings = NULL;
	GSettings* _tmp82_;
	GSettings* _tmp83_;
	GtkSwitch* _tmp84_;
	GSettings* _tmp85_;
	GtkEntry* _tmp86_;
	GSettings* _tmp87_;
	GtkCheckButton* _tmp88_;
	GSettings* _tmp89_;
	GtkCheckButton* _tmp90_;
	parent_class = G_OBJECT_CLASS (pantheon_shell_multitasking_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_SHELL_TYPE_MULTITASKING, PantheonShellMultitasking);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	gtk_widget_set_margin_end ((GtkWidget*) self, 12);
	gtk_widget_set_margin_start ((GtkWidget*) self, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 24);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	_tmp0_ = g_settings_new ("org.pantheon.desktop.gala.behavior");
	_g_object_unref0 (self->priv->behavior_settings);
	self->priv->behavior_settings = _tmp0_;
	_tmp1_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->custom_command_revealer);
	self->priv->custom_command_revealer = _tmp1_;
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("When the cursor enters the corner of the display:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_START);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp2_, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp2_, 6);
	g_object_ref_sink (_tmp2_);
	hotcorner_title = _tmp2_;
	_tmp3_ = hotcorner_title;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
	gtk_style_context_add_class (_tmp4_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp5_ = pantheon_shell_multitasking_create_hotcorner (self);
	_data4_->topleft = _tmp5_;
	_tmp6_ = _data4_->topleft;
	g_signal_connect_data ((GtkComboBox*) _tmp6_, "changed", (GCallback) __pantheon_shell_multitasking___lambda12__gtk_combo_box_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp7_ = _data4_->topleft;
	_tmp8_ = self->priv->behavior_settings;
	_tmp9_ = g_strdup_printf ("%i", g_settings_get_enum (_tmp8_, "hotcorner-topleft"));
	_tmp10_ = _tmp9_;
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp7_, _tmp10_);
	_g_free0 (_tmp10_);
	_tmp11_ = _data4_->topleft;
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
	_tmp12_ = pantheon_shell_multitasking_create_hotcorner (self);
	_data4_->topright = _tmp12_;
	_tmp13_ = _data4_->topright;
	g_signal_connect_data ((GtkComboBox*) _tmp13_, "changed", (GCallback) __pantheon_shell_multitasking___lambda13__gtk_combo_box_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp14_ = _data4_->topright;
	_tmp15_ = self->priv->behavior_settings;
	_tmp16_ = g_strdup_printf ("%i", g_settings_get_enum (_tmp15_, "hotcorner-topright"));
	_tmp17_ = _tmp16_;
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp14_, _tmp17_);
	_g_free0 (_tmp17_);
	_tmp18_ = _data4_->topright;
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
	_tmp19_ = pantheon_shell_multitasking_create_hotcorner (self);
	_data4_->bottomleft = _tmp19_;
	_tmp20_ = _data4_->bottomleft;
	g_signal_connect_data ((GtkComboBox*) _tmp20_, "changed", (GCallback) __pantheon_shell_multitasking___lambda14__gtk_combo_box_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp21_ = _data4_->bottomleft;
	_tmp22_ = self->priv->behavior_settings;
	_tmp23_ = g_strdup_printf ("%i", g_settings_get_enum (_tmp22_, "hotcorner-bottomleft"));
	_tmp24_ = _tmp23_;
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp21_, _tmp24_);
	_g_free0 (_tmp24_);
	_tmp25_ = _data4_->bottomleft;
	gtk_widget_set_valign ((GtkWidget*) _tmp25_, GTK_ALIGN_END);
	_tmp26_ = pantheon_shell_multitasking_create_hotcorner (self);
	_data4_->bottomright = _tmp26_;
	_tmp27_ = _data4_->bottomright;
	g_signal_connect_data ((GtkComboBox*) _tmp27_, "changed", (GCallback) __pantheon_shell_multitasking___lambda15__gtk_combo_box_changed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp28_ = _data4_->bottomright;
	_tmp29_ = self->priv->behavior_settings;
	_tmp30_ = g_strdup_printf ("%i", g_settings_get_enum (_tmp29_, "hotcorner-bottomright"));
	_tmp31_ = _tmp30_;
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp28_, _tmp31_);
	_g_free0 (_tmp31_);
	_tmp32_ = _data4_->bottomright;
	gtk_widget_set_valign ((GtkWidget*) _tmp32_, GTK_ALIGN_END);
	_tmp33_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp33_);
	icon = _tmp33_;
	_tmp34_ = icon;
	g_object_set ((GtkWidget*) _tmp34_, "height-request", 198, NULL);
	_tmp35_ = icon;
	g_object_set ((GtkWidget*) _tmp35_, "width-request", 292, NULL);
	_tmp36_ = icon;
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
	icon_style_context = _tmp37_;
	_tmp38_ = icon_style_context;
	gtk_style_context_add_class (_tmp38_, GRANITE_STYLE_CLASS_CARD);
	_tmp39_ = icon_style_context;
	gtk_style_context_add_class (_tmp39_, "hotcorner-display");
	_tmp40_ = icon_style_context;
	gtk_style_context_add_class (_tmp40_, GRANITE_STYLE_CLASS_ROUNDED);
	_tmp41_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp41_);
	custom_command = _tmp41_;
	_tmp42_ = custom_command;
	g_object_set (_tmp42_, "primary-icon-name", "utilities-terminal-symbolic", NULL);
	_tmp43_ = (GtkLabel*) gtk_label_new (_ ("Custom command:"));
	g_object_ref_sink (_tmp43_);
	cc_label = _tmp43_;
	_tmp44_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp44_);
	cc_grid = _tmp44_;
	_tmp45_ = cc_grid;
	_tmp46_ = gtk_grid_get_column_spacing ((GtkGrid*) self);
	_tmp47_ = _tmp46_;
	gtk_grid_set_column_spacing (_tmp45_, _tmp47_);
	_tmp48_ = cc_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp48_, GTK_ALIGN_END);
	_tmp49_ = cc_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp49_, 24);
	_tmp50_ = cc_grid;
	_tmp51_ = cc_label;
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
	_tmp52_ = cc_grid;
	_tmp53_ = custom_command;
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
	_tmp54_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	cc_sizegroup = _tmp54_;
	_tmp55_ = cc_sizegroup;
	_tmp56_ = icon;
	gtk_size_group_add_widget (_tmp55_, (GtkWidget*) _tmp56_);
	_tmp57_ = cc_sizegroup;
	_tmp58_ = custom_command;
	gtk_size_group_add_widget (_tmp57_, (GtkWidget*) _tmp58_);
	_tmp59_ = self->priv->custom_command_revealer;
	_tmp60_ = cc_grid;
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
	_tmp61_ = (GtkLabel*) gtk_label_new (_ ("Move windows to a new workspace:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp61_, GTK_ALIGN_END);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp61_, 36);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp61_, 12);
	g_object_ref_sink (_tmp61_);
	workspaces_label = _tmp61_;
	_tmp62_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("When entering fullscreen"));
	g_object_ref_sink (_tmp62_);
	fullscreen_checkbutton = _tmp62_;
	_tmp63_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("When maximizing"));
	g_object_ref_sink (_tmp63_);
	maximize_checkbutton = _tmp63_;
	_tmp64_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp64_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp64_, 36);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp64_, 12);
	g_object_ref_sink (_tmp64_);
	checkbutton_grid = _tmp64_;
	_tmp65_ = checkbutton_grid;
	_tmp66_ = fullscreen_checkbutton;
	gtk_container_add ((GtkContainer*) _tmp65_, (GtkWidget*) _tmp66_);
	_tmp67_ = checkbutton_grid;
	_tmp68_ = maximize_checkbutton;
	gtk_container_add ((GtkContainer*) _tmp67_, (GtkWidget*) _tmp68_);
	_tmp69_ = (GtkLabel*) gtk_label_new (_ ("Window animations:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp69_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp69_);
	animations_label = _tmp69_;
	_tmp70_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp70_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp70_);
	animations_switch = _tmp70_;
	_tmp71_ = hotcorner_title;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp71_, 0, 0, 3, 1);
	_tmp72_ = icon;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp72_, 1, 1, 1, 3);
	_tmp73_ = _data4_->topleft;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp73_, 0, 1, 1, 1);
	_tmp74_ = _data4_->topright;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp74_, 2, 1, 1, 1);
	_tmp75_ = _data4_->bottomleft;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp75_, 0, 3, 1, 1);
	_tmp76_ = _data4_->bottomright;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp76_, 2, 3, 1, 1);
	_tmp77_ = self->priv->custom_command_revealer;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp77_, 0, 4, 2, 1);
	_tmp78_ = workspaces_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp78_, 0, 5, 1, 1);
	_tmp79_ = checkbutton_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp79_, 1, 5, 2, 1);
	_tmp80_ = animations_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp80_, 0, 9, 1, 1);
	_tmp81_ = animations_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp81_, 1, 9, 1, 1);
	_tmp82_ = g_settings_new (PANTHEON_SHELL_MULTITASKING_ANIMATIONS_SCHEMA);
	animations_settings = _tmp82_;
	_tmp83_ = animations_settings;
	_tmp84_ = animations_switch;
	g_settings_bind (_tmp83_, PANTHEON_SHELL_MULTITASKING_ANIMATIONS_KEY, (GObject*) _tmp84_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp85_ = self->priv->behavior_settings;
	_tmp86_ = custom_command;
	g_settings_bind (_tmp85_, "hotcorner-custom-command", (GObject*) _tmp86_, "text", G_SETTINGS_BIND_DEFAULT);
	_tmp87_ = self->priv->behavior_settings;
	_tmp88_ = fullscreen_checkbutton;
	g_settings_bind (_tmp87_, "move-fullscreened-workspace", (GObject*) _tmp88_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp89_ = self->priv->behavior_settings;
	_tmp90_ = maximize_checkbutton;
	g_settings_bind (_tmp89_, "move-maximized-workspace", (GObject*) _tmp90_, "active", G_SETTINGS_BIND_DEFAULT);
	_g_object_unref0 (animations_settings);
	_g_object_unref0 (animations_switch);
	_g_object_unref0 (animations_label);
	_g_object_unref0 (checkbutton_grid);
	_g_object_unref0 (maximize_checkbutton);
	_g_object_unref0 (fullscreen_checkbutton);
	_g_object_unref0 (workspaces_label);
	_g_object_unref0 (cc_sizegroup);
	_g_object_unref0 (cc_grid);
	_g_object_unref0 (cc_label);
	_g_object_unref0 (custom_command);
	_g_object_unref0 (icon);
	_g_object_unref0 (hotcorner_title);
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return obj;
}

static void
pantheon_shell_multitasking_class_init (PantheonShellMultitaskingClass * klass,
                                        gpointer klass_data)
{
	pantheon_shell_multitasking_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PantheonShellMultitasking_private_offset);
	G_OBJECT_CLASS (klass)->constructor = pantheon_shell_multitasking_constructor;
	G_OBJECT_CLASS (klass)->finalize = pantheon_shell_multitasking_finalize;
}

static void
pantheon_shell_multitasking_instance_init (PantheonShellMultitasking * self,
                                           gpointer klass)
{
	GeeHashSet* _tmp0_;
	self->priv = pantheon_shell_multitasking_get_instance_private (self);
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->keys_using_custom_command = _tmp0_;
}

static void
pantheon_shell_multitasking_finalize (GObject * obj)
{
	PantheonShellMultitasking * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_SHELL_TYPE_MULTITASKING, PantheonShellMultitasking);
	_g_object_unref0 (self->priv->behavior_settings);
	_g_object_unref0 (self->priv->custom_command_revealer);
	_g_object_unref0 (self->priv->keys_using_custom_command);
	G_OBJECT_CLASS (pantheon_shell_multitasking_parent_class)->finalize (obj);
}

static GType
pantheon_shell_multitasking_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PantheonShellMultitaskingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_shell_multitasking_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonShellMultitasking), 0, (GInstanceInitFunc) pantheon_shell_multitasking_instance_init, NULL };
	GType pantheon_shell_multitasking_type_id;
	pantheon_shell_multitasking_type_id = g_type_register_static (gtk_grid_get_type (), "PantheonShellMultitasking", &g_define_type_info, 0);
	PantheonShellMultitasking_private_offset = g_type_add_instance_private (pantheon_shell_multitasking_type_id, sizeof (PantheonShellMultitaskingPrivate));
	return pantheon_shell_multitasking_type_id;
}

GType
pantheon_shell_multitasking_get_type (void)
{
	static volatile gsize pantheon_shell_multitasking_type_id__volatile = 0;
	if (g_once_init_enter (&pantheon_shell_multitasking_type_id__volatile)) {
		GType pantheon_shell_multitasking_type_id;
		pantheon_shell_multitasking_type_id = pantheon_shell_multitasking_get_type_once ();
		g_once_init_leave (&pantheon_shell_multitasking_type_id__volatile, pantheon_shell_multitasking_type_id);
	}
	return pantheon_shell_multitasking_type_id__volatile;
}

